/*
    Copyright 2005-2008 EPOS-Project
                        (FZ Dresden-Rossendorf & MLU Halle-Wittenberg)
                        Arnold Krille <arnold@arnoldarts.de>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; version 3 of the License.

    This program is distributed in the hope that it will be useful, but
    WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; see the file gpl-3.0.txt. If not, see
    <http://www.gnu.org/licenses/>.

*/

#ifndef NAMEDTREEMODEL_TEST_H
#define NAMEDTREEMODEL_TEST_H

#include <QtCore/QThread>
#include "namedparametertreeitem.h"

class MyThread : public QThread {
	Q_OBJECT
	public:
		MyThread() {
			item = new NSCore::NamedParameterTreeItem( "root", QVariant::Invalid, 0 );
			item->addParameter( "first", 1.0 );
			item->addParameter( "second", 2.0 );
			item->addParameter( "second/first", 2.1 );
			item->addParameter( "second/second", 2.2 );
			item->addParameter( "text", "Bla" );
			item->addParameter( "text/more", "Der ritzerote Ferrari kurvt bei ritzerot um die Kurve!" );

			item->debugPrint();
		}
		void run() {
			exec();
		}

		NSCore::NamedParameterTreeItem* item;

	public slots:
		void addMore() {
			qDebug() << "MyThread::addMore()";
			item->addParameter( "third", 4.5 );
		}
};
#endif // NAMEDTREEMODEL_TEST_H
