/**
 * \namespace NSEvaluation
 *
 * @brief Classes for an extendible EvaluationPath
 *
 * The main part of this namespace is the EvaluationPath, a path to calculate different things on the data and append the results to each dataset. The computation is done by plugins, which are of the following types:
 * <dl>
 * <dt>Analyzer<dd>Analyzes the data and appends results
 * <dt>Filter<dd>Filters for results and executes the subgraph only when matching the filter
 * <dt>Modifier<dd>Modify the data for subgraphs
 * </dl>
 *
 * This library depends on libcore and QtCore.
 */
