/*
    Copyright 2005-2008 EPOS-Project
                        (FZ Dresden-Rossendorf & MLU Halle-Wittenberg)
                        Arnold Krille <arnold@arnoldarts.de>

    This library is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as
    published by the Free Software Foundation; version 3 of the License.

    This library is distributed in the hope that it will be useful, but
    WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; see the files lgpl-3.0.txt and
    gpl-3.0.txt. If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef QTREEITEMMODELDELEGATE_H
#define QTREEITEMMODELDELEGATE_H

#include <QtGui/QItemDelegate>

#include <guiserver_interface.h>

class QTreeItemModelDelegate : public QItemDelegate
{
	Q_OBJECT
	public:
		QTreeItemModelDelegate( QObject* =0 );
		QTreeItemModelDelegate( NSCore::GuiServer_Interface*, QObject* =0 );

		void paint( QPainter*, const QStyleOptionViewItem&, const QModelIndex& ) const;

		bool editorEvent( QEvent*, QAbstractItemModel*, const QStyleOptionViewItem&, const QModelIndex& );

		QSize sizeHint( const QStyleOptionViewItem&, const QModelIndex& ) const;

	private:
		void init();
		NSCore::GuiServer_Interface* _gui;
};

#endif // TREEITEMMODELDELEGATE_H

