/*
    Copyright 2005-2008 EPOS-Project
                        (FZ Dresden-Rossendorf & MLU Halle-Wittenberg)
                        Arnold Krille <arnold@arnoldarts.de>

    This library is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as
    published by the Free Software Foundation; version 3 of the License.

    This library is distributed in the hope that it will be useful, but
    WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; see the files lgpl-3.0.txt and
    gpl-3.0.txt. If not, see <http://www.gnu.org/licenses/>.

*/

#include "stackediconwidget.h"
#include "stackediconwidget.moc"

#include "stackediconwidget_base.h"

#include <QtGui/QIcon>
#include <QtCore/QDebug>

StackedIconWidget::StackedIconWidget( QWidget* p ) : QFrame( p ) {
	_base = new Ui::StackedIconWidget_Base();
	_base->setupUi( this );
	while ( _base->stackedWidget->count() > 0 )
		_base->stackedWidget->removeWidget( _base->stackedWidget->currentWidget() );

	connect( _base->listWidget, SIGNAL( currentRowChanged( int ) ), _base->stackedWidget, SLOT( setCurrentIndex( int ) ) );
	connect( _base->stackedWidget, SIGNAL( widgetRemoved( int ) ), this, SLOT( childDestroyed( int ) ) );
}
StackedIconWidget::~StackedIconWidget() {
}

void StackedIconWidget::addWidget( QString st, QWidget* w, QString icon ) {
	if ( icon == "" )
		icon = "";
	new QListWidgetItem( QIcon( icon ), st, _base->listWidget );
	_base->stackedWidget->addWidget( w );
}

void StackedIconWidget::childDestroyed( int n ) {
	_base->listWidget->takeItem( n );
}

