/*
    Copyright 2005-2008 EPOS-Project
                        (FZ Dresden-Rossendorf & MLU Halle-Wittenberg)
                        Arnold Krille <arnold@arnoldarts.de>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; version 3 of the License.

    This program is distributed in the hope that it will be useful, but
    WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; see the file gpl-3.0.txt. If not, see
    <http://www.gnu.org/licenses/>.

*/
#include <QtCore/QDebug>
#include <math.h>
#include <iostream>

#include "interpolation_helpers.h"

class MySpline : public Spline
{
	public:
		MySpline( double* y, int n, double yp1, double ypn ) : Spline( y, n, yp1, ypn ) {}

		double y( int n ) {
			qDebug() << "MySpline::y(" << n << ")";
			if ( n<_n && n>=0 )
				return _y[ n ];
			return 0;
		}
};

double func( double x, int size ) {
	//return sin( x/size * 2*M_PI );
	return exp( - pow( x/size - 0.5, 2 )/0.01 );
}

int main(  int argc, char** argv )
{
	qDebug() << "Interpolation Test starting...";

	const int size = 50;

	double* data = new double[ size ];
	for ( int i=0; i<size; ++i ) {
		data[ i ] = func( i, size );
	}

	for ( int i=0; i<size; ++i )
		std::cout << i << "\t" << data[ i ] << std::endl;
	std::cout << std::endl << std::endl;

	MySpline* int_low = new MySpline( data, size, 0, 0 );
	//int_low->setData( data );
	//PolynomInterpolate* int_mid = new PolynomInterpolate( 2 );
	//int_mid->setData( data );
	//PolynomInterpolate* int_hig = new PolynomInterpolate( 2 );
	//int_hig->setData( data );
	for ( int i=1; i<size-2; ++i ) {
		//int_low->setMiddle( i-1 );
		//int_mid->setMiddle( i );
		//int_hig->setMiddle( i+1 );
		for ( double j=0; j<1; j+=0.1 )
			std::cout << i+j
				<< "\t" << int_low->splint( i+j )
				<< "\t" << func( i+j, size)
				<< "\t" << fabs( ( int_low->splint( i+j ) - func( i+j, size ) ) )
				//<< "\t" << fabs( ( int_mid->polint( i+j ) - func( i+j, size ) ) )
				//<< "\t" << fabs( ( int_hig->polint( i+j ) - func( i+j, size) ) )
				<< std::endl;
	}


	qDebug() << "...finished.";
	return 0;
}

