/*
    Copyright 2005-2008 EPOS-Project
                        (FZ Dresden-Rossendorf & MLU Halle-Wittenberg)
                        Arnold Krille <arnold@arnoldarts.de>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; version 3 of the License.

    This program is distributed in the hope that it will be useful, but
    WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; see the file gpl-3.0.txt. If not, see
    <http://www.gnu.org/licenses/>.

*/

#ifndef SIMPLEDISKWRITER_H
#define SIMPLEDISKWRITER_H

#include "simplediskwriter_gui.h"
#include <QtGui/QWidget>

namespace NSAcqiris {
	class Acqiris;
};

class OsciWidgetV3;

namespace NSDiskIO {
	class EPOSBinWriter;
	class DiskWriterGui;
};

class QSettings;

class SimpleDiskWriterGui : public QWidget, private Ui::SimpleDiskWriterGui_Base
{
	Q_OBJECT
	public:
		SimpleDiskWriterGui( NSAcqiris::Acqiris*, QWidget* );
		~SimpleDiskWriterGui();

	protected slots:
		void toggleDisk( bool );
		void toggleOsci( bool );
	
	private:
		OsciWidgetV3* _osci;
		NSAcqiris::Acqiris* _acqiris;
		NSDiskIO::EPOSBinWriter* _writer;
		NSDiskIO::DiskWriterGui* _writergui;

		QSettings* _settings;
};

#endif // SIMPLEDISKWRITER_H

